/*
										Scripted by: Rezil
										--------------------------------
										Contact detail:
										
										xfire: saberteeth
										e-mail: Rezil@CoDJumper.com
										--------------------------------
										If you have any questions, either add me on xfire or
										send me en e-mail.
										--------------------------------
										
										Health picking up and respawning logic
-------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------------
										Requirements:
										- At least one trigger named "health_pickup_*", where * is the type of health("big", "med" or "small")
									    - At least one script_model named "health_origin_*", where * is the type of health("big", "med" or "small")
										- The ammount of triggers and script_models has to be the same
										--------------------------------
										How it works:
										
										- Call setupHealthPickup somewhere in your main level script,
										  near the begining(before any wait commands are called!). 
										- 'health_type' is the type of health, it can be either small, med or big
										- 'delay' is the delay in seconds after which the health will respawn
*/

setupHealthPickup(health_type, delay)
{
	if(health_type=="big")
	{
		precachemodel("xmodel/health_large");
	}
	else if(health_type=="med")
	{
		precachemodel("xmodel/health_medium");
	}
	else if(health_type=="small")
	{
		precachemodel("xmodel/health_small");
	}
	trig = getentarray("health_pickup_" +health_type,"targetname");
	org = getentarray("health_origin_" +health_type,"targetname");
	if(org.size == trig.size) //same ammount of origins and triggers, otherwise you get errors
	{
		for(i=0;i<org.size;i++)
		{
			trig[i] thread healthPickup(org[i], health_type, delay);
		}
	}
}

healthPickup(o, health, delay)
{
	while(1)
	{
		if(health=="big")
		{
			o setmodel("xmodel/health_large");
		}
		else if(health=="med")
		{
			o setmodel("xmodel/health_medium");
		}
		else if(health=="small")
		{
			o setmodel("xmodel/health_small");
		}
		o notsolid();
		self waittill("trigger", user);
		if(user.health<100) 
		{ //not at full health
			if(health=="big")
			{
				user.health = user.health + 100;
				user iprintln("You picked up a large medkit");
			}
			else if(health=="med")
			{
				user.health = user.health + 50;
				user iprintln("You picked up a medium medkit");
			}
			else if(health=="small")
			{
				user.health = user.health + 25;
				user iprintln("You picked up a small medkit");
			}
			o playsound("health_pickup");
			o hide();
			if(user.health>100) user.health = 100; //debug
			self maps\mp\_utility::TriggerOff();
			
			wait delay;
			
			self maps\mp\_utility::TriggerOn();
			//o playsound("health_respawned");
			o show();
		}
		else 
		{
			wait 0.05;
		}
	}
}