#include maps\mp\_utility;
//made by rezil, do not modify!
/*	Valid custom functions and their explanations:
	(All of these functions are meant to be called on a player!)
	
		addStatusBarItem(string)
			- Adds text to the top-left part of the rezBar. String has to be localized.
		
		statusBarSmallEnabled(state)
			- Controls whether rezBar is enabled or not. Boolean(1=enabled, 0=disabled).
			
		statusBarBigEnabled()
			- Enables the right, bigger part of the rezBar. This is usually reserved for various pieces of paper(HUD 2D images).
			
		statusBarBigMakeNote(shader)
			- Draw a 2D HUD image, where the big status bar is. Ingame statusBarBigEnabled should be called first, then statusBarBigMakeNote.
			
		holsterWeapons(what_do)
			- Removes the weapons, as if they are holstered. Is a wait function, so it either has to be threaded or waited out.
			
		readBook(shader)
			- Similar to statusBarBigMakeNote(shader), only this time it draws the shader fullscreen. Used for picking up the Biology book.
			
		addRezBarSeekFunction()
			- Used only once, for making the 'seek mode' HUD elements.
			
		compareDistanceToEntity(target_targetname)
			- For seek mode, compares the distance from user to 'target_targetname'(targetname of the entity being looked for). MUST BE THREADED!
			
		makeCamera(arg)
			- Variable arg is boolean. If true, makes the user a camera(basically invisible). If false, turns the user back to the original playermodel.
			
		rotatePlayerAngles(direction, a, up, delay)
			- Rotates the player in the direction 'direction', which can be either "clockwise" or "counterclockwise". The variable 'a' is the angle to
			  which to rotate the player relative to his original angle. Up is a boolean variable, if true will rotate up -- only use for small angles
			  as you cannot rotate 360 degrees vertically. Delay is how long it takes to rotate to angle 'a'. HAS TO BE THREADED!
			
		makeCinematic(arg)
			- Sets up the cinematic(aspect ratio black bars, disabling HUD etc.). Arg is boolean. If true, make the view cinematic, if false, return it
			  back to normal.
			  
		drawUserChoicesBJ()
			- Draw Hit, Stand and Double along with the selection rectangle (Blackjack), then prompt the user to select one with MELEE and confirm his
			  choice with ATTACK
			
		hideUserChoicesBJ()
			- Hide Hit, Stand and Double along with the selection rectangle (Blackjack)
			
		checkUserChoiceChange()
			- Check player switching between Hit, Stand and Double and his selection
			
		enableRezPod(state)
			- Enables or disables the rezPod according to state <state>, which can be 1 or 0.
			
		makeRezpod()
			- Make the rezPod elements. Don't use as standalone.
			
		monitorRezPodChoice()
			- When rezPod is active, check which song is chosen and play it accordingly.
			
		checkIfRezPodIsEnabled()
			- Always monitors player when he'll press Shift+use and opens the rezPod.
*/
addStatusBarItem(string)
{
	if(!isdefined(self.kuwehrTempItem))
	{
		self.kuwehrTempItem = newclientHudElem(self);
		self.kuwehrTempItem.x = 10;
		self.kuwehrTempItem.y = 125;
		self.kuwehrTempItem.alignX = "left";
		self.kuwehrTempItem.alignY = "bottom";
		self.kuwehrTempItem.horzAlign = "left";
		self.kuwehrTempItem.vertAlign = "top";
		self.kuwehrTempItem.font = "default"; 
		self.kuwehrTempItem.alpha = 1; 
		self.kuwehrTempItem.fontScale = 1;	
		self.kuwehrTempItem.archived = false;
		self.kuwehrTempItem.color = (1, 1, 1);
		self.kuwehrTempItem settext(string);
	}
	else 
	{
		self.kuwehrTempItem.alpha = 1;
		self.kuwehrTempItem settext(string);
	}
	
	if(string==&"RZL_INIT_REZBAR_DONE") self playlocalsound("rezbar_status_initialised");
	else self playlocalsound("rezbar_status_sfx");
	//self iprintln("Sound played locally.");
	self.kuwehrTempItem fadeovertime(2);
	self.kuwehrTempItem.alpha = 0;
}

statusBarSmallEnabled(state) //state can be 1 or 0. 1=enabled, 0=disabled
{
	if((!isdefined(self.playerOverlay)) && (!isdefined(self.HUDstatusOfWaypoint)) && (!isdefined(self.HUDstatusOfWaypoint_txt)) && (!isdefined(self.HUDwaypointHint)))
	{
		self.playerOverlay = newclientHudElem(self);
		self.playerOverlay.x = 6;
		self.playerOverlay.y = 51;
		self.playerOverlay.horzAlign = "left";
		self.playerOverlay.vertAlign = "top";
		self.playerOverlay.alpha = 0.5;
		self.playerOverlay setshader("kuwehr_status_bar_overlay", 150, 79);
		
		self.HUDstatusOfWaypoint = newclientHudElem(self);
		self.HUDstatusOfWaypoint.x = 70;
		self.HUDstatusOfWaypoint.y = 65;
		self.HUDstatusOfWaypoint.alignX = "left";
		self.HUDstatusOfWaypoint.alignY = "bottom";
		self.HUDstatusOfWaypoint.horzAlign = "left";
		self.HUDstatusOfWaypoint.vertAlign = "top";
		self.HUDstatusOfWaypoint.font = "default"; 
		self.HUDstatusOfWaypoint.fontScale = .8;	
		self.HUDstatusOfWaypoint.archived = false;
		self.HUDstatusOfWaypoint.color = (1, 0, 0);
		self.HUDstatusOfWaypoint.label = &"RZL_WAYPOINT_MODE_OFF";
		
		self.HUDstatusOfWaypoint_txt = newclientHudElem(self);
		self.HUDstatusOfWaypoint_txt.x = 10;
		self.HUDstatusOfWaypoint_txt.y = 65;
		self.HUDstatusOfWaypoint_txt.alignX = "left";
		self.HUDstatusOfWaypoint_txt.alignY = "bottom";
		self.HUDstatusOfWaypoint_txt.horzAlign = "left";
		self.HUDstatusOfWaypoint_txt.vertAlign = "top";
		self.HUDstatusOfWaypoint_txt.font = "default"; 
		self.HUDstatusOfWaypoint_txt.fontScale = .8;	
		self.HUDstatusOfWaypoint_txt.archived = false;
		self.HUDstatusOfWaypoint_txt.color = (1, 1, 1);
		self.HUDstatusOfWaypoint_txt.label = &"RZL_WAYPOINT_MODE_TEXT";
		
		self.HUDwaypointHint = newclientHudElem(self);
		self.HUDwaypointHint.x = 10;
		self.HUDwaypointHint.y = 73;
		self.HUDwaypointHint.alignX = "left";
		self.HUDwaypointHint.alignY = "bottom";
		self.HUDwaypointHint.horzAlign = "left";
		self.HUDwaypointHint.vertAlign = "top";
		self.HUDwaypointHint.font = "default"; 
		self.HUDwaypointHint.alpha = 1; 
		self.HUDwaypointHint.fontScale = .65;	
		self.HUDwaypointHint.archived = false;
		self.HUDwaypointHint.color = (0.4, 0.4, 0.4);
		self.HUDwaypointHint.label = &"RZL_WAYPOINT_MODE_HINT";
		
		self.HUDmoney_left = newclientHudElem(self);
		self.HUDmoney_left.x = 10;
		self.HUDmoney_left.y = 102;
		self.HUDmoney_left.alignX = "left";
		self.HUDmoney_left.alignY = "bottom";
		self.HUDmoney_left.horzAlign = "left";
		self.HUDmoney_left.vertAlign = "top";
		self.HUDmoney_left.font = "default"; 
		self.HUDmoney_left.alpha = 1; 
		self.HUDmoney_left.fontScale = .8;	
		self.HUDmoney_left.archived = false;
		self.HUDmoney_left.color = (1,1,1);
		self.HUDmoney_left.label = &"RZL_KUWEHR_MONEY_HUD";
		self.HUDmoney_left setValue(self.kuwehr_money);
		
		
	}
	
	if(state==0)
	{
		self.HUDstatusOfWaypoint.alpha = 0;
		self.HUDstatusOfWaypoint_txt.alpha = 0;
		self.HUDwaypointHint.alpha = 0;
		self.HUDmoney_left.alpha = 0;
		if((isdefined(self.HUDrezbarSeek_txt)) && (isdefined(self.HUDrezbarSeekHint)) && (isdefined(self.HUDrezbarSeekInd)))
		{
			self.HUDrezbarSeek_txt.alpha = 0;
			self.HUDrezbarSeekHint.alpha = 0;
			self.HUDrezbarSeekInd.alpha = 0;
			
			self.HUDrezbarSeek_item_txt.alpha = 0;
		}
	}                           
	else if(state==1)
	{
		self.HUDstatusOfWaypoint.alpha = 1;
		self.HUDstatusOfWaypoint_txt.alpha = 1;
		self.HUDwaypointHint.alpha = 1;
		self.HUDmoney_left.alpha = 1;
		if((isdefined(self.HUDrezbarSeek_txt)) && (isdefined(self.HUDrezbarSeekHint)) && (isdefined(self.HUDrezbarSeekInd)))
		{
			self.HUDrezbarSeek_txt.alpha = 1;
			self.HUDrezbarSeekHint.alpha = 1;
			self.HUDrezbarSeekInd.alpha = 1;
			
			self.HUDrezbarSeek_item_txt.alpha = 1;
		}
	}
}

statusBarBigEnabled() //run function on user. Will wait until user presses melee, then hide this menu
{
	if(!isdefined(self.playerBigOverlay))
	{
		self.playerBigOverlay = newclientHudElem(self);
		self.playerBigOverlay.x = 0;
		self.playerBigOverlay.y = 0;
		self.playerBigOverlay.alignX = "left";
		self.playerBigOverlay.alignY = "top";
		self.playerBigOverlay.horzAlign = "fullscreen";
		self.playerBigOverlay.vertAlign = "fullscreen";	
		self.playerBigOverlay.foreground = 1;
		self.playerBigOverlay.alpha = 0;
		self.playerBigOverlay setshader("kuwehr_status_big", 650, 480);
	}
	
	self.playerBigOverlay fadeovertime(0.3);
	self.playerBigOverlay.alpha = 0.5;
	if(isdefined(self.big_statusbar_enabled)) self.big_statusbar_enabled = true;
	if(isdefined(self.waypoint_mode_enabled)) self.waypoint_mode_enabled = false;
	if(isdefined(self.rezpod_able_to_use)) self.rezpod_able_to_use = false;
	if((isdefined(self.seek_mode_enabled)) && (self.opened_updater_pack)) self.seek_mode_enabled = false;
	
	self freezecontrols(true);
	
	if(self.updating_rezbar) self playlocalsound("rezbar_look_note");
	self.kuwehr_current_state = "reading";
	self statusBarSmallEnabled(0);
	self thread statusBarBigCheckMelee();
	
}

statusBarBigCheckMelee()
{
	for(;;)
	{
		if(self meleebuttonpressed())
		{
			self.playerBigOverlay fadeovertime(0.3);
			self.playerBigOverlay.alpha = 0;
			if(isdefined(self.big_statusbar_enabled)) self.big_statusbar_enabled = false;
			if(isdefined(self.waypoint_mode_enabled)) self.waypoint_mode_enabled = true;
			if(isdefined(self.rezpod_able_to_use)) self.rezpod_able_to_use = true;
			if((isdefined(self.seek_mode_enabled)) && (self.opened_updater_pack)) self.seek_mode_enabled = true;
			
			self playlocalsound("rezbar_put_away_book");
			self.kuwehr_current_state = "normal";
			self freezecontrols(false);
			
			self notify("done_checking_rezbar_big");
			
			self statusBarSmallEnabled(1);
			break;
		}
		wait 0.05;
	}
}

statusBarBigMakeNote(shader)
{
	if(!isdefined(self.kuwehrStatusBarBigNote))
	{
		self.kuwehrStatusBarBigNote = newclientHudElem(self);
		self.kuwehrStatusBarBigNote.x = 290;
		self.kuwehrStatusBarBigNote.y = 90;
		self.kuwehrStatusBarBigNote.alignX = "left";
		self.kuwehrStatusBarBigNote.alignY = "top";	
		self.kuwehrStatusBarBigNote.foreground = 1;
		self.kuwehrStatusBarBigNote.alpha = 0;
		self.kuwehrStatusBarBigNote setshader(shader, 245, 245);
	}
	
	self.kuwehrStatusBarBigNote fadeovertime(0.3);
	self.kuwehrStatusBarBigNote.alpha = 1;
	self.kuwehrStatusBarBigNote setshader(shader, 245, 245);
	self thread monitorStatusBarBigEnabled();
}
monitorStatusBarBigEnabled()
{
	for(;;)
	{
		if(isdefined(self.big_statusbar_enabled))
		{
			if(!self.big_statusbar_enabled)
			{
				self.kuwehrStatusBarBigNote fadeovertime(0.3);
				self.kuwehrStatusBarBigNote.alpha = 0;
				break;
			}
		}
		wait 0.05;
	}
}

holsterWeapons(what_do) //Call on player, is a WAIT function! what_do is either "holster" or "retrieve"
{
	if(!isdefined(self.primary)) self.primary = self getweaponslotweapon("primary");
	if(!isdefined(self.secondary)) self.secondary = self getweaponslotweapon("primaryb");
	if(what_do=="holster")
	{
		if(self getcurrentweapon()==self.primary) self switchtoweapon(self.secondary);
		else if(self getcurrentweapon()==self.secondary) self switchtoweapon(self.primary);
		wait 0.24;
		self takeallweapons();
	}
	else if(what_do=="retrieve")
	{
			self giveweapon(self.primary);
			self giveweapon(self.secondary);
			self givemaxammo(self.primary);
			self givemaxammo(self.secondary);
			self switchtoweapon(self.primary);
	}
}

readBook(shader) //run function on user. Will wait until user presses melee, then hide this menu
{
	if(!isdefined(self.readBookOverlay))
	{
		self.readBookOverlay = newclientHudElem(self);
		self.readBookOverlay.x = 0;
		self.readBookOverlay.y = 0;
		self.readBookOverlay.alignX = "left";
		self.readBookOverlay.alignY = "top";
		self.readBookOverlay.horzAlign = "fullscreen";
		self.readBookOverlay.vertAlign = "fullscreen";	
		self.readBookOverlay.foreground = 1;
		self.readBookOverlay.alpha = 0;
	}
	
	self.readBookOverlay setshader(shader, 650, 480);
	
	self.readBookOverlay fadeovertime(0.8);
	self.readBookOverlay.alpha = 1;
	if(isdefined(self.big_statusbar_enabled)) self.big_statusbar_enabled = true;
	if(isdefined(self.waypoint_mode_enabled)) self.waypoint_mode_enabled = false;
	if(isdefined(self.rezpod_able_to_use)) self.rezpod_able_to_use = false;
	if((isdefined(self.seek_mode_enabled)) && (self.opened_updater_pack)) self.seek_mode_enabled = false;
	if(isdefined(self.playerOverlay)) 
		{
			self.playerOverlay fadeovertime(0.8);
			self.playerOverlay.alpha = 0;
		}
		
	self setclientcvar("hud_enable","0");
	
	self freezecontrols(true);
	
	self playlocalsound("rezbar_reading_book");
	self.kuwehr_current_state = "reading";
	self statusBarSmallEnabled(0);
	self thread readBookCheckMelee();
	
}

readBookCheckMelee()
{
	for(;;)
	{
		if(self meleebuttonpressed())
		{
			self.readBookOverlay fadeovertime(0.8);
			self.readBookOverlay.alpha = 0;
			if(isdefined(self.big_statusbar_enabled)) self.big_statusbar_enabled = false;
			if(isdefined(self.waypoint_mode_enabled)) self.waypoint_mode_enabled = true;
			if(isdefined(self.rezpod_able_to_use)) self.rezpod_able_to_use = true;
			if((isdefined(self.seek_mode_enabled)) && (self.opened_updater_pack)) self.seek_mode_enabled = true;
			if(isdefined(self.playerOverlay)) 
			{
				self.playerOverlay fadeovertime(0.8);
				self.playerOverlay.alpha = 0.5;
			}
			
			self playlocalsound("rezbar_put_away_book");
			self.kuwehr_current_state = "normal";
			
			self setclientcvar("hud_enable","1");
			self notify("done_reading");
			
			self freezecontrols(false);
			
			self statusBarSmallEnabled(1);
			break;
		}
		wait 0.05;
	}
}

addRezBarSeekFunction()
{
	if((!isdefined(self.HUDrezbarSeek_txt)) && (!isdefined(self.HUDrezbarSeekHint)) && (!isdefined(self.HUDrezbarSeekInd)) && (!isdefined(self.HUDrezbarSeek_item_txt)))
	{
		self.HUDrezbarSeek_txt = newclientHudElem(self);
		self.HUDrezbarSeek_txt.x = 10;
		self.HUDrezbarSeek_txt.y = 85;
		self.HUDrezbarSeek_txt.alignX = "left";
		self.HUDrezbarSeek_txt.alignY = "bottom";
		self.HUDrezbarSeek_txt.horzAlign = "left";
		self.HUDrezbarSeek_txt.vertAlign = "top";	
		self.HUDrezbarSeek_txt.font = "default"; 
		self.HUDrezbarSeek_txt.fontScale = .8;	
		self.HUDrezbarSeek_txt.archived = false;
		self.HUDrezbarSeek_txt.color = (1, 1, 1);
		self.HUDrezbarSeek_txt.label = &"RZL_SEEK_MODE_TEXT";
		
		self.HUDrezbarSeekHint = newclientHudElem(self);
		self.HUDrezbarSeekHint.x = 10;
		self.HUDrezbarSeekHint.y = 93;
		self.HUDrezbarSeekHint.alignX = "left";
		self.HUDrezbarSeekHint.alignY = "bottom";
		self.HUDrezbarSeekHint.horzAlign = "left";
		self.HUDrezbarSeekHint.vertAlign = "top";	
		self.HUDrezbarSeekHint.font = "default"; 
		self.HUDrezbarSeekHint.alpha = 1; 
		self.HUDrezbarSeekHint.fontScale = .65;	
		self.HUDrezbarSeekHint.archived = false;
		self.HUDrezbarSeekHint.color = (0.4, 0.4, 0.4);
		self.HUDrezbarSeekHint.label = &"RZL_SEEK_MODE_HINT";
		
		self.HUDrezbarSeekInd = newclientHudElem(self);
		self.HUDrezbarSeekInd.x = 55;
		self.HUDrezbarSeekInd.y = 86;
		self.HUDrezbarSeekInd.alignX = "left";
		self.HUDrezbarSeekInd.alignY = "bottom";
		self.HUDrezbarSeekInd.horzAlign = "left";
		self.HUDrezbarSeekInd.vertAlign = "top";	
		self.HUDrezbarSeekInd.font = "default"; 
		self.HUDrezbarSeekInd.fontScale = 1.2;	
		self.HUDrezbarSeekInd.archived = false;
		self.HUDrezbarSeekInd.color = (1, 1, 1);
		self.HUDrezbarSeekInd.label = &"RZL_BLANK";
		
		self.HUDrezbarSeek_item_txt = newclientHudElem(self);
		self.HUDrezbarSeek_item_txt.x = 60;
		self.HUDrezbarSeek_item_txt.y = 85;
		self.HUDrezbarSeek_item_txt.alignX = "left";
		self.HUDrezbarSeek_item_txt.alignY = "bottom";
		self.HUDrezbarSeek_item_txt.horzAlign = "left";
		self.HUDrezbarSeek_item_txt.vertAlign = "top";	
		self.HUDrezbarSeek_item_txt.font = "default"; 
		self.HUDrezbarSeek_item_txt.fontScale = .8;	
		self.HUDrezbarSeek_item_txt.archived = false;
		self.HUDrezbarSeek_item_txt.color = (1, 1, 1);
		self.HUDrezbarSeek_item_txt.label = self.current_target;
	}
}

compareDistanceToEntity(target_targetname)
{
	self endon("got_to_seeking_item");
	
	if(target_targetname=="none") ent = spawn("script_origin", (-10000, -10000, -10000));
	else ent = getent(target_targetname,"targetname");
	
	for(;;)
	{
		if((self.seek_mode_enabled) && (self.seek_mode=="on"))
		{
			if(target_targetname != "none")
			{
				temp = distance(self.origin, ent.origin);
				dist = int(temp);
				//iprintln("^8checked distance");
				if(dist>200)
				{
					//iprintln("^4distance more than 200 units");
					self.HUDrezbarSeekInd.label = &"RZL_SEEK_COLD";
					self.target_radius="cold";
				}
				else if((dist<=200) && (dist>=125))
				{
					self.HUDrezbarSeekInd.label = &"RZL_SEEK_WARM";
					self.target_radius="cold";
				}
				else if((dist<=125) && (dist>=50))
				{
					self.HUDrezbarSeekInd.label = &"RZL_SEEK_WARM";
					self.target_radius="warm";
				}
				else if(dist<50)
				{
					self.HUDrezbarSeekInd.label = &"RZL_SEEK_HOT";
					self.target_radius="hot";
				}
			}
			else
			{
				self.HUDrezbarSeekInd.label = &"RZL_SEEK_COLD";
				self.target_radius="cold";
				break;
			}
		}
		wait 0.1;
	}
}

makeCamera(arg)
{
	if(!isdefined(self.isCamera)) self.isCamera = false;
	
	if((arg) && (!self.isCamera))
	{
		self detachall();
		self setmodel("");
		self.isCamera = true;
	}
	else
	{
		if(self.pers["team"]=="allies") 
		{
			self setmodel(level.american_xmodel);
			self attach(level.german_xmodel_head, "", true);
			self attach(self.hatModel, "", true);
		}
		else if(self.pers["team"]=="axis") 
		{
			self setmodel(level.german_xmodel);
			self attach(level.german_xmodel_head, "", true);
			self attach(self.hatModel, "", true);
		}
		self.isCamera = false;
	}
}

rotatePlayerAngles(direction, a, up, delay)
{
	if(a<=0) return;
	
	for(i=0;i<=a;i++)
	{
		angles = self getplayerangles();
		if(direction=="clockwise") 
		{
			if(!up) self setplayerangles(angles-(0,1,0));
			else self setplayerangles(angles+(1,0,0));
		}
		else 
		{
			if(!up) self setplayerangles(angles-(0,1,0));
			else self setplayerangles(angles+(1,0,0));
		}
		wait (delay/a);
	}
	
}

makeCinematic(arg)
{
	if(!isdefined(self.isInCinematic)) self.isInCinematic = false; 
	
	if((!isdefined(self.cineTopBar)) && (!isdefined(self.cineBottomBar)))
	{
		self.cineTopBar = newclienthudelem(self);
		self.cineTopBar.x = 0;
		self.cineTopBar.y = 425;
		self.cineTopBar.horzAlign = "fullscreen";		
		self.cineTopBar.alignY = "top";
		self.cineTopBar.foreground = 1;
		self.cineTopBar setshader("black", 640, 80);

		self.cineBottomBar = newClientHudElem(self);
		self.cineBottomBar.x = 0;
		self.cineBottomBar.y = 50;
		self.cineBottomBar.horzAlign = "fullscreen";
		self.cineBottomBar.alignY = "bottom";
		self.cineBottomBar.foreground = 1;
		self.cineBottomBar setshader("black", 640, 80);
	}
	
	if((arg) && (!self.isInCinematic))
	{
		self.cineTopBar.alpha = 1;
		self.cineBottomBar.alpha = 1;
		self.playerOverlay.alpha = 0;
	
		self.isInCinematic = true;
		
		self setclientcvar("hud_enable", "0");
		self setclientcvar("cg_drawfps","0");
		
		self statusBarSmallEnabled(false);
		
		if(isdefined(self.waypoint_mode_enabled)) self.waypoint_mode_enabled = false;
		if(isdefined(self.rezpod_able_to_use)) 
		{
			self playlocalsound("local_null");
			self.rezpod_able_to_use = false;
		}
		if((isdefined(self.seek_mode_enabled)) && (self.opened_updater_pack)) self.seek_mode_enabled = false;
	}
	else if((!arg) && (self.isInCinematic))
	{
		self.cineTopBar.alpha = 0;
		self.cineBottomBar.alpha = 0;
		self.playerOverlay.alpha = 0.5;
	
		self.isInCinematic = false;
		
		self setclientcvar("hud_enable", "1");
		self setclientcvar("cg_drawfps","1");
		
		self statusBarSmallEnabled(true);
		
		if(isdefined(self.waypoint_mode_enabled)) self.waypoint_mode_enabled = true;
		if(isdefined(self.rezpod_able_to_use)) self.rezpod_able_to_use = true;
		if((isdefined(self.seek_mode_enabled)) && (self.opened_updater_pack)) self.seek_mode_enabled = true;
	}
}
drawBJScoreHUD()
{
	if(!isdefined(self.bj_player_score_HUD))
	{
		self.bj_player_score_HUD = newclienthudelem(self);
		self.bj_player_score_HUD.horzAlign = "center";
		self.bj_player_score_HUD.vertAlign = "top";
		self.bj_player_score_HUD.font = "default"; 
		self.bj_player_score_HUD.fontScale = 1.2; 
		self.bj_player_score_HUD.x = 0;
		self.bj_player_score_HUD.y = 60;
		self.bj_player_score_HUD.archived = false;
		self.bj_player_score_HUD.label = &"RZL_BLACKJACK_PLAYERSCORE";
		self.bj_player_score_HUD setvalue(self.bj_score); 
	}
	if(!isdefined(self.bj_player_score_HUDace))
	{	
		self.bj_player_score_HUDace = newclienthudelem(self);
		self.bj_player_score_HUDace.horzAlign = "center";
		self.bj_player_score_HUDace.vertAlign = "top";
		self.bj_player_score_HUDace.font = "default"; 
		self.bj_player_score_HUDace.fontScale = 1.2; 
		self.bj_player_score_HUDace.x = 50;
		self.bj_player_score_HUDace.y = 60;
		self.bj_player_score_HUDace.archived = false;
		self.bj_player_score_HUDace.label = &"RZL_BLANK";
	}
	if(!isdefined(self.bj_dealer_score_HUD))
	{
		self.bj_dealer_score_HUD = newclienthudelem(self);
		self.bj_dealer_score_HUD.horzAlign = "center";
		self.bj_dealer_score_HUD.vertAlign = "top";
		self.bj_dealer_score_HUD.font = "default"; 
		self.bj_dealer_score_HUD.fontScale = 1.2; 
		self.bj_dealer_score_HUD.x = 0;
		self.bj_dealer_score_HUD.y = 30;
		self.bj_dealer_score_HUD.archived = false;
		self.bj_dealer_score_HUD.label = &"RZL_BLACKJACK_DEALERSCORE";
		self.bj_dealer_score_HUD setvalue(self.bj_dealer_score); 
	}
	if(!isdefined(self.bj_dealer_score_HUDace))
	{	
		self.bj_dealer_score_HUDace = newclienthudelem(self);
		self.bj_dealer_score_HUDace.horzAlign = "center";
		self.bj_dealer_score_HUDace.vertAlign = "top";
		self.bj_dealer_score_HUDace.font = "default"; 
		self.bj_dealer_score_HUDace.fontScale = 1.2; 
		self.bj_dealer_score_HUDace.x = 50;
		self.bj_dealer_score_HUDace.y = 30;
		self.bj_dealer_score_HUDace.archived = false;
		self.bj_dealer_score_HUDace.label = &"RZL_BLANK";
	}
}

drawUserChoicesBJ(state)
{
	if((!isdefined(self.choice_bj_hit)) && (!isdefined(self.choice_bj_stand)) && (!isdefined(self.choice_bj_double)) && (!isdefined(self.choice_bj_rectangle)))
	{
		self.choice_bj_hit = newclienthudelem(self);
		self.choice_bj_hit.horzAlign = "left";
		self.choice_bj_hit.vertAlign = "top";
		self.choice_bj_hit.font = "default"; 
		self.choice_bj_hit.fontScale = 1.2; 
		self.choice_bj_hit.x = 60;
		self.choice_bj_hit.y = 130;
		self.choice_bj_hit.archived = false;
		self.choice_bj_hit setText(&"RZL_BLACKJACK_HIT"); 

		self.choice_bj_stand = newclienthudelem(self);
		self.choice_bj_stand.horzAlign = "left";
		self.choice_bj_stand.vertAlign = "top";
		self.choice_bj_stand.font = "default"; 
		self.choice_bj_stand.fontScale = 1.2; 
		self.choice_bj_stand.x = 60;
		self.choice_bj_stand.y = 150;
		self.choice_bj_stand.archived = false;
		self.choice_bj_stand setText(&"RZL_BLACKJACK_STAND"); 
                 
		self.choice_bj_double = newclienthudelem(self);
		self.choice_bj_double.horzAlign = "left";
		self.choice_bj_double.vertAlign = "top";
		self.choice_bj_double.font = "default"; 
		self.choice_bj_double.fontScale = 1.2; 
		self.choice_bj_double.x = 60;
		self.choice_bj_double.y = 170;
		self.choice_bj_double.archived = false;
		self.choice_bj_double setText(&"RZL_BLACKJACK_DOUBLE"); 
		
		self.choice_bj_rectangle = newclienthudelem(self);
		self.choice_bj_rectangle.horzAlign = "left";
		self.choice_bj_rectangle.vertAlign = "top";
		self.choice_bj_rectangle.x = 60;
		self.choice_bj_rectangle.y = 130;
		self.choice_bj_rectangle.archived = false;
		self.choice_bj_rectangle setShader("kuwehr_blackjack_rec_choice",42,15); 
		
	}                          
	
	self.choice_bj_hit.color = (1, 1, 1);
	self.choice_bj_stand.color = (1, 1, 1);
	self.choice_bj_double.color = (1, 1, 1);
	
	if(self.current_bj_choice == "hit") self.choice_bj_hit.color = (.5,.5,.5);
	else if(self.current_bj_choice == "stand") self.choice_bj_stand.color = (.5,.5,.5);
	else if(self.current_bj_choice == "double") self.choice_bj_double.color = (.5,.5,.5);
	
	self.choice_bj_hit.alpha = 1;
	self.choice_bj_stand.alpha = 1;
	if(level.bj_doubleHidden) self.choice_bj_double.alpha = 0;
	else self.choice_bj_double.alpha = 1;
	
	self.choice_bj_rectangle.alpha = 0.5;
	
	self thread checkUserChoiceChange();
}

hideUserChoicesBJ()
{
	if((isdefined(self.choice_bj_hit)) && (isdefined(self.choice_bj_stand)) && (isdefined(self.choice_bj_double)) && (isdefined(self.choice_bj_rectangle)))
	{
		self.choice_bj_hit.alpha = 0;
		self.choice_bj_stand.alpha = 0;
		self.choice_bj_double.alpha = 0;
		self.choice_bj_rectangle.alpha = 0;
	}
}

checkUserChoiceChange()
{
	for(;;)
	{
		if(self meleeButtonPressed()) wait 0.05; if(self meleeButtonPressed())
		{
			choice = self.current_bj_choice;
			
			switch(choice)
			{
				case "hit":
				  self.current_bj_choice = "stand";
				  self.choice_bj_hit.color = (1, 1, 1);
				  self.choice_bj_stand.color = (.5, .5, .5);
				  self.choice_bj_rectangle.y = 150;
				  break;
				case "stand":
				  self.choice_bj_stand.color = (1, 1, 1);
				  if(!level.bj_doubleHidden)
				  {
					self.current_bj_choice = "double";
					self.choice_bj_double.color = (.5, .5, .5);
					self.choice_bj_rectangle.y = 170;
				  }
				  else
				  {
					self.current_bj_choice = "hit";
					self.choice_bj_hit.color = (.5, .5, .5);
					self.choice_bj_rectangle.y = 130;
				  }
				  break;
				case "double":
				  self.current_bj_choice = "hit";
				  self.choice_bj_double.color = (1, 1, 1);
				  self.choice_bj_hit.color = (.5, .5, .5);
				  self.choice_bj_rectangle.y = 130;
				  break;
			}
		}
		else if(self attackButtonPressed()) 
		{
			wait 0.05;
			if(self attackButtonPressed())
			{
				self notify("made_choice");
				break;
			}
		}
		wait 0.05;
		
	}
}
enableRezPod(state)
{
	if((!isdefined(self.rezpod_interface)) && (!isdefined(self.rezpod_selector))) self makeRezPod();
	if(state==0)
	{
		self freezeControls(false);
		self.rezpod_interface moveovertime(0.5);
		self.rezpod_interface fadeovertime(0.5);
		self.rezpod_interface.x = 0;
		self.rezpod_interface.y = 150;
		self.rezpod_interface.alpha = 0;
		self.rezpod_selector.x = 21;
		self.rezpod_selector.y = 161;
		self.rezpod_selector.alpha = 0;
		
		self.rezpod_enabled = 0;
	}                           
	else if(state==1)
	{
		self freezeControls(true);
		self.rezpod_interface moveovertime(0.5);
		self.rezpod_interface fadeovertime(0.5);
		self.rezpod_interface.x = 12;
		self.rezpod_interface.y = 150;
		self.rezpod_interface.alpha = .7;
		wait 0.5;
		self.rezpod_selector.alpha = .7;
		
		self.rezpod_enabled = 1;
		self monitorRezPodChoice();
	}
}
makeRezpod()
{
	
	self.rezpod_interface = newclienthudelem(self);
	self.rezpod_interface.horzAlign = "left";
	self.rezpod_interface.vertAlign = "top";
	self.rezpod_interface.x = 0;
	self.rezpod_interface.y = 150;
	self.rezpod_interface.archived = false;
	self.rezpod_interface setshader("rezpod_interface",90,185);
	self.rezpod_interface.alpha = 0; 
	
	self.rezpod_selector = newclienthudelem(self);
	self.rezpod_selector.horzAlign = "left";
	self.rezpod_selector.vertAlign = "top";
	self.rezpod_selector.x = 21;
	self.rezpod_selector.y = 161;
	self.rezpod_selector.archived = false;
	self.rezpod_selector setshader("rezpod_selector",73,9); 	
	self.rezpod_selector.alpha = 0;
}
monitorRezPodChoice()
{
/*
	- self.rezpod_choice equals the soundalias to play!
	- songs:
		ex_za_ex
		m_exploder
		testify
		ring_of_fire
		shake_that
	
*/
    if(!isdefined(self.rezpod_choice)) self.rezpod_choice = "ex_za_ex";
	
	for(;;)
	{
		if(self meleeButtonPressed()) 
		{
			wait 0.05;
			if(self useButtonPressed())
			{
				self.rezpod_choice = "ex_za_ex";
				break;
			}
			else if(self meleeButtonPressed())
			{
				
				switch(self.rezpod_choice)
				{
					case "ex_za_ex":
					  self.rezpod_choice = "m_exploder";
					  self.rezpod_selector.y += 9; 
					  break;
					case "m_exploder":
					  self.rezpod_choice = "testify";
					  self.rezpod_selector.y += 9; 
					  break;
					case "testify":
					  self.rezpod_choice = "ring_of_fire";
					  self.rezpod_selector.y += 10; 
					  break;
					case "ring_of_fire":
					  self.rezpod_choice = "shake_that";
					  self.rezpod_selector.y += 9; 
					  break;
					case "shake_that":
					  self.rezpod_choice = "stop_rezpod";
					  self.rezpod_selector.y += 20; 
					  break;
					case "stop_rezpod":
					  self.rezpod_choice = "ex_za_ex";
					  self.rezpod_selector.y = 161; 
					  break;
				}
			}
		}
		else if(self useButtonPressed()) wait 0.05; if(self useButtonPressed())
		{
			switch(self.rezpod_choice)
			{
				case "ex_za_ex":
				  self.rezpod_choice = "stop_rezpod";
				  self.rezpod_selector.y = 218; 
				  break;
				case "m_exploder":
				  self.rezpod_choice = "ex_za_ex";
				  self.rezpod_selector.y -= 9; 
				  break;
				case "testify":
				  self.rezpod_choice = "m_exploder";
				  self.rezpod_selector.y -= 10; 
				  break;
				case "ring_of_fire":
				  self.rezpod_choice = "testify";
				  self.rezpod_selector.y -= 9; 
				  break;
				case "shake_that":
				  self.rezpod_choice = "ring_of_fire";
				  self.rezpod_selector.y -= 9; 
				  break;
				case "stop_rezpod":
				  self.rezpod_choice = "shake_that";
				  self.rezpod_selector.y -= 20; 
				  break;
			}
		}
		else if(self attackButtonPressed())
		{
			if(self.rezpod_choice=="stop_rezpod") self playlocalsound("local_null");
			else self playlocalsound(self.rezpod_choice);
			self.rezpod_choice = "ex_za_ex";
			break;
		}
		wait 0.05;
	}
	
	wait 0.5;
	enableRezPod(0);


}
checkIfRezPodIsEnabled()
{
	for(;;)
	{
		if(self.rezpod_able_to_use)
		{
			if(self meleeButtonPressed()) 
			{
				wait 0.1; 
				if(self useButtonPressed()) 
				{
					if(self.rezpod_enabled==0) 
					{
						enableRezPod(1);
						wait 0.5;
					}
				}
			}
		}
		wait 0.05;
	}
}