#include maps\mp\_kuwehr_functions;
#include maps\mp\_utility;
//made by rezil, do not modify!

/* 
////////////////////////////////////////////////////////////////////////
Core function:

<ent> dealCard(<person>, <value>, <suite>, <position>, <cardnum>);


  1   2   3   4   5   -POSITIONS (<position>)
|-------------------|
| 1 | 3 | 5 | 7 | 9 | -CARD
|-------------------|
| 0 | 2 | 4 | 6 | 8 |  INDEXES (<cardnum>)
|-------------------|

Cards:

<value>:			<suite>:
---------------------------------------
1 = Ace				1 = Spades
2-10 = 2-10			2 = Clubs
11 = Jack			3 = Diamonds
12 = Queen			4 = Hearts
13 = King

People to deal to:

<person> is either "self" or "dealer". If "self", it will deal to the bottom
part of the screen(positions 0, 2, 4, 6, 8), if "dealer" it will deal to the top.

////////////////////////////////////////////////////////////////////////
*/
main()
{
	//precachemenu("rezil_blackjackmenu");
	level.static_final_bj_trigger = "kuwehr_minigame_blackjack_game";
	level.default_delay_time = 1.25;
	thread trig_start();
}

trig_start()
{
	t = getent(level.static_final_bj_trigger,"targetname");
	while(1)
	{
		t waittill("trigger", user);
		
		user freezeControls(true);
		
		//user setclientcvar("rez_blackjack_money_bet", "2000");//------------------------TEMP MENU STUFF
		
		t triggerOff();
		user thread initgame();
		wait 2.5;
	}
}


initGame()
{
	self.bj_score = 0; //Your score 0-21, over is bust
	self.bj_dealer_score = 0; //Dealers score 0-21, stand on 17-21, otherwise must hit!
	self.bj_pos["player"] = 1; //Positions, check top of code for explanation
	self.bj_pos["dealer"] = 1; //Positions, check top of code for explanation
	self.bj_card_index = 0;	//Index of the card being dealt, a variable because I'm too lazy
							//to keep track of each time I draw a card to update the index manually
	level.card1_dealer_index = -1; //TEMP
	level.revealed_dealer_Card = false;
	level.bj_doubleHidden = false; //Hide 'Double' thing after first card dealt with 'Hit'
	self.current_bj_choice = "hit"; //Where the rectangle is
	self.updatingScore = false; // Whether the score is currently being updated
	self.game_reset = false; //for the infinite while loop in updateBJScores();, also when checking blackjack!
	self.double_choice = false; //For betting, whether you bet double or not

	//self openMenu("rezil_blackjackmenu");//-------------------------------------------TEMP MENU STUFF
	
	if(isdefined(self.rezpod_able_to_use)) self.rezpod_able_to_use = false;
	
	self betMoney();
	wait .05;
	if(self.had_enough_money)
	{
		self drawBJScoreHUD();
		wait .05;
		
		self dealFirstTwoCards();
		
		self.bj_score = self.card[0].game_value + self.card[2].game_value;
		self.bj_dealer_score = self.card[1].game_value + self.card[3].game_value;
		
		self thread updateBJScores();
		
		/*if(self.card[3].game_value==1) iprintln("Dealer: "+(self.bj_dealer_score-self.card[1].game_value)+"/"+(self.bj_dealer_score-self.card[1].game_value+10));
		else self iprintln("Dealer: "+(self.bj_dealer_score-self.card[1].game_value)); //-self.card[1].game_value because the card is hidden, will add to score after the card is reveal (TODO)
		if((self.card[0].game_value==1) || (self.card[2].game_value==1)) iprintln("Player: "+self.bj_score+"/"+(self.bj_score+10));
		else self iprintln("Player: "+self.bj_score);*/
		
		if(!self.game_reset) self waitForInput();
	}
	else 
	{
		self iprintlnbold("You don't have enough money to play!\nYou need at least 100^2$^7.");
		self resetGame();
	}
}

dealFirstTwoCards()
{
	
	self dealRandomCard("self", self.bj_pos["player"], self.bj_card_index);
	
	self dealRandomCard("dealer", self.bj_pos["dealer"], self.bj_card_index);
	
	level.card1_dealer_index = self.bj_card_index; //Need to remember this because it will be revealed later
	
	self.bj_pos["player"]++;
	self.bj_pos["dealer"]++;
	
	self dealRandomCard("self", self.bj_pos["player"], self.bj_card_index);
	
	self dealRandomCard("dealer", self.bj_pos["dealer"], self.bj_card_index);
	
	self.bj_pos["player"]++;
	self.bj_pos["dealer"]++;
	
	wait 0.5;
	
	//self iprintlnbold("My cards: "+self.card[0].game_value+ " and " +self.card[2].game_value+ ". Dealer cards: " +self.card[1].game_value+ " and " +self.card[3].game_value+ ".");
	
	if(checkBlackjack(self.card[0].game_value, self.card[2].game_value))
	{
		self.blackjacked = "self";
		self.card[1] setShader("white",72,96);
		self.card2d[1].alpha = 1;
		self.card2d_suite[1].alpha = 1;
		level.revealed_dealer_Card = true;
		self.bj_player_score_HUD setvalue(self.bj_score);
		self.bj_dealer_score_HUD setvalue(self.bj_score);
		wait 2;
		personLost("dealer");
		iprintlnbold("Blackjack!");
	}
	else if(checkBlackjack(self.card[1].game_value, self.card[3].game_value))
	{
		self.blackjacked = "dealer";
		self.card[1] setShader("white",72,96);
		self.card2d[1].alpha = 1;
		self.card2d_suite[1].alpha = 1;
		level.revealed_dealer_Card = true;
		self.bj_player_score_HUD setvalue(self.bj_score);
		self.bj_dealer_score_HUD setvalue(self.bj_score);
		wait 2;
		personLost("self");
	}
}
dealRandomCard(person, position, cardnum)
{
	self dealCard(person, randomInt(13)+1, undefined, position, cardnum);
}

//Draws a HUD image of a playing card with the value 'value' to the specified person 'person' in the specified suite 'suite'. cardnum is the card index(can only be occupied by 1 card)
dealCard(person, value, suite, position, cardnum)
{
	self.drawing_card = true;
	if(!isdefined(self.card)) self.card = [];
	
	if(!isdefined(self.card[cardnum])) 
	{
		self.card[cardnum] = newclientHudElem(self);
		self.card[cardnum].alignX = "left";
		self.card[cardnum].alignY = "top";	
		self.card[cardnum].alpha = 1;
	}
	self.card[cardnum].x = 240;
	self.card[cardnum].y = 0;
	self.card[cardnum] setshader("ho_back", 36, 48);
	self.card[cardnum] moveovertime(0.2);
	self.card[cardnum] scaleovertime(0.2);
	
	switch(position)
	{
		case 1:
		  if(person=="self") self.card[cardnum] setCardXY(190, 240);
		  else if(person=="dealer") self.card[cardnum] setCardXY(190, 80);
		  break;
		case 2:
		  if(person=="self") self.card[cardnum] setCardXY(270, 240);
		  else if(person=="dealer") self.card[cardnum] setCardXY(270, 80);
		  break;
		case 3:
		  if(person=="self") self.card[cardnum] setCardXY(350, 240);
		  else if(person=="dealer") self.card[cardnum] setCardXY(350, 80);
		  break;
		case 4:
		  if(person=="self") self.card[cardnum] setCardXY(430, 240);
		  else if(person=="dealer") self.card[cardnum] setCardXY(430, 80);
		  break;
		case 5:
		  if(person=="self") self.card[cardnum] setCardXY(510, 240);
		  else if(person=="dealer") self.card[cardnum] setCardXY(510, 80);
		  break;
		default:
		  iprintln("^3*^10 position set(or is greater than 5), ERROR!^3*");
		  break;
	}
	
	wait 0.25;
	
	if((position==1) && (person=="dealer")) 
	{
		self.card[cardnum] setshader("ho_back", 72, 96);
		//self iprintln("Dealer hidden card position: "+position+" and index: " +cardnum+". Global index is:^3" +level.card1_dealer_index);
		
		self drawCard(value, suite, self.card[cardnum].x, self.card[cardnum].y, true, cardnum);
	}
	else 
	{
		self.card[cardnum] setshader("white", 72, 96);
		self drawCard(value, suite, self.card[cardnum].x, self.card[cardnum].y, false, cardnum);
	}
	
	if(value>10) self.card[cardnum].game_value=10; 
	else self.card[cardnum].game_value=value;
	
	
	self.bj_card_index++;
	if(randomint(2)==0) self playlocalsound("bj_dealcard1");
	else self playlocalsound("bj_dealcard2");
	
	self.drawing_card = false;
	
	return self.card[cardnum].game_value;
}

//gets the correct shader name to use
getShaderFromCard(value, suite)
{
	shader_name = "";
	
	if(!isdefined(suite))
	{
		r = randomInt(2);
		if(r==0) shader_name = "b";
		else shader_name = "r";
	}
	else
	{
		if((suite==1) || (suite==2)) shader_name = "b";
		else shader_name = "r";
	}
	
	shader_name = shader_name+"_";
	switch(value)
	{
		case 1:
		  shader_name = shader_name+"A";
		  break;
		case 2:
		  shader_name = shader_name+"2";
		  break;
		case 3:
		  shader_name = shader_name+"3";
		  break;
		case 4:
		  shader_name = shader_name+"4";
		  break;
		case 5:
		  shader_name = shader_name+"5";
		  break;
		case 6:
		  shader_name = shader_name+"6";
		  break;
		case 7:
		  shader_name = shader_name+"7";
		  break;
		case 8:
		  shader_name = shader_name+"8";
		  break;
		case 9:
		  shader_name = shader_name+"9";
		  break;
		case 10:
		  shader_name = shader_name+"10";
		  break;
		case 11:
		  shader_name = shader_name+"J";
		  break;
		case 12:
		  shader_name = shader_name+"Q";
		  break;
		case 13:
		  shader_name = shader_name+"K";
		  break;
		default:
		  iprintln("^1card value is 0, ERROR!^3*");
		  break;
	}
	
	return shader_name;
}

setCardXY(x_val, y_val)
{
	self.x = x_val;
	self.y = y_val;
}

checkBlackjack(value1, value2)
{
	if((value1 == 1) || (value2==1))
	{
		value1+=10; //doesn't matter which card gets 10 added, if either of them is an ace
		if(value1+value2==21) return true;
		else return false;
	}
	else return false; //need an ace for a blackjack
}

drawCard(value, suite, x_pos, y_pos, dealerFirst, index) //draw suite, dealerFirst is the hidden card dealt at pos 1
{
	if(!isdefined(self.card2d)) self.card2d = [];
	if(!isdefined(self.card2d_suite)) self.card2d_suite = [];
	
	
	if((!isdefined(self.card2d[index])) && (!isdefined(self.card2d_suite[index])))
	{
		self.card2d[index] = newclienthudelem(self);
		self.card2d[index].alignX = "left";
		self.card2d[index].alignY = "top";
		self.card2d[index].x = x_pos+32;
		self.card2d[index].y = y_pos+32;
		
		shader = getShaderFromCard(value, suite);
		
		self.card2d[index] setshader(shader,32,32);
		
		self.card2d_suite[index] = newclienthudelem(self);
		self.card2d_suite[index].alignX = "right";
		self.card2d_suite[index].alignY = "top";
		self.card2d_suite[index].x = x_pos+32;
		self.card2d_suite[index].y = y_pos+32;
		
		self.card2d_suite[index] setshader(getCardSuite(shader, suite),32,32);
		
		index++;
	}
	if(!dealerFirst) 
	{
		self.card2d[index-1].alpha = 1;
		self.card2d_suite[index-1].alpha = 1;
	}
	else 
	{
		self.card2d[index-1].alpha = 0;
		self.card2d_suite[index-1].alpha = 0;
	}
}

getCardSuite(shader, suite)
{
	suite_shdr = "";
	
	if(!isdefined(suite))
	{
		card_color = strtok(shader,"_");
		
		if(card_color[0] == "b")
		{
			if(randomInt(2)==0) suite_shdr = "b_spades";
			else suite_shdr = "b_clubs";
		}
		else if(card_color[0] == "r")
		{
			if(randomInt(2)==0) suite_shdr = "r_hearts";
			else suite_shdr = "r_dmnds";
		}
	}
	else //1 = spades, 2 = clubs, 3 = diamonds, 4 = hearts
	{
		switch(suite)
		{
			case 1:
			  suite_shdr = "b_spades";
			  break;
			case 2:
			  suite_shdr = "b_clubs";
			  break;
			case 3:
			  suite_shdr = "r_dmnds";
			  break;
			case 4:
			  suite_shdr = "r_hearts";
			  break;
			  
		}
	}
	
	return suite_shdr;
}

destroyAllCards()
{
	self.bj_player_score_HUD destroy();
	self.bj_player_score_HUDace destroy();
	self.bj_dealer_score_HUD destroy();
	self.bj_dealer_score_HUDace destroy();
	
	if(isdefined(self.card))
	{
		card = self.card;
		for(i=0;i<card.size;i++) 
		{
			if(isdefined(self.card[i]))
			{
				self.card[i] destroy();
				self.card2d[i] destroy();
				self.card2d_suite[i] destroy();
			}
		}
	}
}

waitForInput()
{
	self drawUserChoicesBJ();
	
	self waittill("made_choice");
	
	self hideUserChoicesBJ();
	choice = self.current_bj_choice;
	
	switch(choice)
	{
		case "hit":
		  self thread goToHit();
		  break;
		case "stand":
		self thread goToStand();
		  break;
		case "double":
		self thread goToDouble();
		  break;
	}
}

goToHit()
{
	self dealRandomCard("self", self.bj_pos["player"], self.bj_card_index);
	self.bj_score = self.bj_score + self.card[self.bj_card_index-1].game_value;
	
	if(self.bj_pos["player"]==3) level.bj_doubleHidden = true;
	
	if((self.bj_pos["player"] >= 5) && (self.bj_score<=21)) self dealerDeal();
	
	else if(self.bj_score>21) 
	{
		wait level.default_delay_time;
		self personLost("self");
	}
	else
	{
		self.bj_pos["player"]++;
		wait level.default_delay_time;
		self thread waitForInput();
	}
	
}

goToStand()
{
	self dealerDeal();
}

goToDouble()
{
	if(self.kuwehr_money>=100)
	{
		self.kuwehr_money -= 100;
		self.double_choice = true;
		self iprintlnbold("You double your bet.");
		wait 0.5;
		self dealRandomCard("self", self.bj_pos["player"], self.bj_card_index);
		self.bj_score = self.bj_score + self.card[self.bj_card_index-1].game_value;
		self.bj_pos["player"]++;
		
		if(self.bj_score>21) 
		{
			wait level.default_delay_time;
			self personLost("self");
		}
		else 
		{
			wait level.default_delay_time;
			self dealerDeal();
		}
	}
	else 
	{
		self iprintln("You can't bet double because you don't have enough money!");
		wait 0.5;
		self waitForInput();
	}
}

dealerDeal()
{
	self.card[1] setShader("white",72,96);
	self.card2d[1].alpha = 1;
	self.card2d_suite[1].alpha = 1;
	level.revealed_dealer_Card = true;
	wait 1;
	
	dealerLostBefore = false;
	
	for(;;)
	{
		if(self.bj_dealer_score>=17) break;
		if(checkIfAceFromPerson("dealer") && self.bj_dealer_score+10>=17 && self.bj_dealer_score+10<=21) break; //Ace with score inbetween 17-21
		else if(self.bj_dealer_score>21) 
		{
			personLost("dealer");
			dealerLostBefore = true;
			break;
		}
		self dealRandomCard("dealer", self.bj_pos["dealer"], self.bj_card_index);
		self.bj_dealer_score = self.bj_dealer_score + self.card[self.bj_card_index-1].game_value;
		
		self.bj_pos["dealer"]++;
		wait level.default_delay_time;
	}
	
	if((!dealerLostBefore) && (self.bj_dealer_score <= 21)) self compareBJScores(self.bj_score, self.bj_dealer_score);
	else if((!dealerLostBefore) && (self.bj_dealer_score > 21)) personLost("dealer");
	
}

updateBJScores()
{
	self.updatingScore = true;
	while(self.updatingScore)
	{
		if(self.drawing_card) wait 0.05;
		else if(isdefined(self.bj_player_score_HUD))
		{
			//-------------Player-------------
			self.bj_player_score_HUD.label = &"RZL_BLACKJACK_PLAYERSCORE";
			ace = checkIfAceFromPerson("self"); //returns boolean
			
			if(ace) 
			{
				self.bj_player_score_HUDace.label = &"RZL_BLACKJACK_PLAYER_SLASH";
				self.bj_player_score_HUDace setvalue(self.bj_score+10);
			}
			else
			{
				self.bj_player_score_HUDace destroy();
				self drawBJScoreHUD();
			}
			self.bj_player_score_HUD setvalue(self.bj_score);
		
			//-------------Dealer-------------
			self.bj_dealer_score_HUD.label = &"RZL_BLACKJACK_DEALERSCORE";
			ace = checkIfAceFromPerson("dealer"); //returns boolean
			
			if(ace) 
			{
				self.bj_dealer_score_HUDace.label = &"RZL_BLACKJACK_SLASH";
				if(!level.revealed_dealer_Card) self.bj_dealer_score_HUDace setvalue(self.bj_dealer_score-self.card[1].game_value+10); 
				else self.bj_dealer_score_HUDace setvalue(self.bj_dealer_score+10);
			}
			else
			{
				self.bj_dealer_score_HUDace destroy();
				self drawBJScoreHUD();
			}
			if(!level.revealed_dealer_Card) self.bj_dealer_score_HUD setvalue(self.bj_dealer_score-self.card[1].game_value); 
			else self.bj_dealer_score_HUD setvalue(self.bj_dealer_score);
			
			if(self.game_reset) break;
		}
		wait 0.2;
	}
}

personLost(person) //"self" or "dealer"
{
	if(person=="self") 
	{
		self playlocalsound("bj_lose");
		wait 0.25;
		self iprintlnbold("You lose.");
		//Lost 100$
		if(self.blackjacked == "dealer") self.kuwehr_money -= 100; //Lost double because of dealer BJ
		self resetGame();	
	}
	else if(person=="dealer")
	{
		self playlocalsound("bj_win");
		wait 0.25;
		self iprintlnbold("You win.");
		//self playlocalsound("got_money");
		if(self.blackjacked == "self") self.kuwehr_money += 100; //Won double because of your BJ (1.5 of bet)
		else if(self.double_choice) self.kuwehr_money += 200; //2.0 of bet - 200% more
		self.kuwehr_money += 200; //100 bet + 100 from winning
		self resetGame();	
	}
	else if(person=="none")
	{
		wait 0.25;
		self iprintlnbold("Push.");
		self.kuwehr_money += 100; //You get your money back
		self resetGame();
	}
	
}

checkIfAceFromPerson(person)
{
	gotAce = false;
	
	if(person=="self") 
	{
		for(i=0;i<10;i+=2) //0,2,4,6,8
		{
			if(isdefined(self.card[i]))
			{
				//iprintln("Card index: "+i+ ". Value: " +self.card[i].game_value);
				if(self.card[i].game_value==1) //ace
				{
					gotAce = true;
					break; //GTFO loop
				}
			}
		}		
		
		if(gotAce)
		{
			if((self.bj_score+10) > 21) return false;
			else return true;
		}
		
		else return false;
	}
	else if(person=="dealer")
	{
		if(level.revealed_dealer_Card) a = 1;
		else a = 3;
		
		for(i=a;i<10;i+=2) //1,3,5,7,9
		{
			if(isdefined(self.card[i]))
			{
				//iprintln("Card index: "+i+ ". Value: " +self.card[i].game_value);
				if(self.card[i].game_value==1) //ace
				{
					gotAce = true;
					break; //GTFO loop
				}
			}
		}
		
		if(gotAce)
		{
			if((self.bj_dealer_score+10) > 21) return false;
			else return true;
		}
		
		else return false;
	}
}

resetGame()
{
	self destroyAllCards();
	self.updatingScore = false;
	self.game_reset = true;
	self.blackjacked = "none";
	self.choice_bj_rectangle.y = 130;
	if(isdefined(self.rezpod_able_to_use)) self.rezpod_able_to_use = true;
	
	self freezeControls(false);
	wait 2;
	getent(level.static_final_bj_trigger,"targetname") triggerOn();
}

compareBJScores(playerscore, dealerscore)
{
	playerace = checkIfAceFromPerson("self");
	if(playerace) playerscore += 10;
	
	dealerace = checkIfAceFromPerson("dealer");
	if(dealerace) dealerscore += 10;
	
	
	if(playerscore==dealerscore) personLost("none");
	else if(playerscore>dealerscore) personLost("dealer");
	else if(dealerscore>playerscore) personLost("self");
}
betMoney()
{
	self.had_enough_money = false;
	if(isdefined(self.kuwehr_money))
	{
		if(self.kuwehr_money>=100) 
		{
			self.had_enough_money = true;
			self.kuwehr_money -= 100;
			//self playlocalsound("got_money");
			self iprintlnbold("You bet 100^2$^7.");
		}
	}
}