#include maps\mp\_utility;
#include maps\mp\_health_pickup;
#include maps\mp\gametypes\_objpoints;
#include maps\mp\_kuwehr_functions;
/*
										Scripted by: Rezil
										--------------------------------
										Contact detail:
										
										xfire: saberteeth
										e-mail: Rezil@CoDJumper.com
										--------------------------------
										If you have any questions, either add me on xfire or
										send me en e-mail.
										--------------------------------
										
										Level code for jm_kuwehr (Part 1)
-------------------------------------------------------------------------------------------------------------------------------------------------------------
*/

main()
{
	maps\mp\_load::main();
	maps\mp\_kuwehr_precaches::main();
	maps\mp\_kuwehr_pack::main();
	maps\mp\_kuwehr_waypoints::main();
	maps\mp\_wall_torch_flame::main();
	maps\mp\_kuwehr_mini_tictactoe::main();
	maps\mp\_kuwehr_mini_blackjack::main();
	maps\mp\_kuwehr_seekmode::main();
	
	setupHealthPickup("big", 10);
	setupHealthPickup("med", 5);
	setupHealthPickup("small", 2.5);
	
	setExpFog(0.00015, 242/255, 190/255, 132/255, 0);
	
	ambientPlay("ambient_kuwehr");

	//  VARIABLES
	level.hinges_destroyed=0;

	level.german_xmodel = "xmodel/playerbody_german_normandy01";
	level.german_xmodel_head = "xmodel/head_german_normandy_josh";
	//level.german_xmodel_hat = "xmodel/helmet_german_normandy";

	level.american_xmodel = "xmodel/playerbody_default";         
	level.american_xmodel_head = "xmodel/head_us_ranger_preston";
	//level.american_xmodel_hat = "xmodel/helmet_us_ranger_generic";

	//---------------------------------------------------------------------------------------------------------------
		
	//  PRECACHES
	precacheModel(level.american_xmodel);
	precacheModel(level.american_xmodel_head);
	//precacheModel(level.american_xmodel_hat);

	precacheModel(level.german_xmodel);
	precacheModel(level.german_xmodel_head);
	//precacheModel(level.german_xmodel_hat);
	//---------------------------------------------------------------------------------------------------------------

	//	THREADS
	thread kuwehr_huge_door_lever();
	thread kuwehr_hinge_thing();
	thread kuwehr_start();
	thread playorz();
	thread kuwehr_main_door_small_locked_door();
	thread kuwehr_library_door_entry();
	thread kuwehr_library_door_exit();
	thread pick_up_library_key();
	thread user_wine_drinking();
	thread found_the_right_book();
	thread key_under_rug();
	thread kuwehr_enter_part_two();
	thread cinematic_rez_courtyard();
	thread easter_egg_1();
	thread easter_egg_2();
	thread getTemplatedDoors();
	thread kuwehr_end_money();
	thread end_barrier_1();
	thread end_barrier_2();
	thread kuwehr_mansion_enter();
	thread kuwehr_end();
	//---------------------------------------------------------------------------------------------------------------
	getent("kuwehr_library_exit","targetname") sethintstring("Unfortunately, the cursor hints aren't avaliable in this room.");
	getent("kuwehr_money_barrier_2_1000bucks","targetname") sethintstring("You need 1000^2$ ^7to remove this barrier");

}

playorz()
{
	for(;;)
	{
		p = getentarray("player", "classname");
		for(i=0;i<p.size;i++) 
		{
		if ((!isdefined(p[i].reset2)) && (isalive(p[i])))
			{
			p[i].reset2 = true;
			
			p[i].big_statusbar_enabled = false;
			p[i].kuwehr_current_state = "normal"; //valid keys are 'normal' and 'reading'
			
			p[i].has_library_key = false;
			p[i].has_main_door_key = false;
			p[i].took_library_door_note = false;
			
			p[i].opened_intro_pack = false;
			p[i].opened_main_door_pack = false;
			p[i].opened_prison_pack = false;
			p[i].opened_hinges_pack = false;
			p[i].opened_guardtower_pack = false;
			p[i].opened_updater_pack = false;
			p[i].opened_rezpod_pack = false;
			
			p[i].alco_tolerance = 0;
			p[i].drunk = false;
			p[i].reading_book = false;
			p[i].note_from_book_dropped = false;
			p[i].solved_puzzle = false;
			p[i].has_key_to_part_two = false;
			p[i].rezpod_able_to_use = true;
			p[i].kuwehr_money = 0; 
			p[i] thread monitorMoney();
			
			p[i].finished_kuwehr = false;
			//p[i] thread origin_pl();
			
			}
		}
		wait 0.05;
	}
}
/*origin_pl()
{
	for(;;)
	{
		self iprintln(self.origin);
		wait 2;
	}
}*/

kuwehr_huge_door_lever()
{
	t = getent("kuwehr_hugeroom_lever_trig","targetname");
	l = getent("kuwehr_hugeroom_lever","targetname");
	d = getent("kuwehr_hugeroom_lever_door","targetname");
	kill = getent("kuwehr_lever_kill","targetname"); //FIX!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
	for(;;)
	{
		t waittill("trigger", user);
		l rotateroll(-90,1.5,0.3,0.2);
		l playsound("kuwehr_lever");
		l waittill("rotatedone");
		wait 1;
		d movez(90,1);
		//d playsound("steel_door_move_up");
		wait 3;
		d movez(-90,1);
		l rotateroll(90,0.5,0.2,0.2);
		wait 1;
	}
}

kuwehr_hinge_thing()
{
	thread kuwehr_guardtower_hinges();
	thread kuwehr_check_destroyed_hinges();
}

kuwehr_guardtower_hinges()
{
	d = getentarray("kuwehr_guardtower_hinge_dmg","targetname");
	h = getentarray("kuwehr_guardtower_hinge","targetname");
	for(i=0;i<d.size;i++)
	{
		d[i] thread hinge_think(h[i]);
	}
}

hinge_think(h)
{
	self waittill("trigger", user);
	if(randomInt(2)==0) h playsound("kill_hinge_1");
	else h playsound("kill_hinge_2");
	h hide();
	h notsolid();
	level.hinges_destroyed++;
	self triggeroff();
}

kuwehr_check_destroyed_hinges()
{
	d = getent("kuwehr_guardtower_hinged_door","targetname");
	
	for(;;)
	{
		if(level.hinges_destroyed==4)
		{
			d notsolid();
			d rotateroll(100,1,0.1,0.6);
			wait 1;
			d rotateroll(-20,0.9,0.1,0.6);
			wait 0.9;
			d rotateroll(15,0.9,0.1,0.6);
			wait 0.9;
			d rotateroll(-15,0.7,0.1,0.6);
			wait 0.7;
			d rotateroll(10,0.2);
			wait 1;
			return;
		}
		else wait 0.05;
	}
}

kuwehr_start()
{
	t = getent("kuwehr_intro_trigger", "targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isdefined(user.triggeredIntro)) 
		{
			user thread kuwehr_proper_intro();
			user.triggeredintro = true;
		}
	}
}

rezbar_intro_init()
{
	self statusBarSmallEnabled(0);
	self addStatusBarItem(&"RZL_INIT_REZBAR");
	wait 2;
	self addStatusBarItem(&"RZL_INIT_REZBAR");
	wait 2;
	self addStatusBarItem(&"RZL_INIT_REZBAR_DONE");
	self statusBarSmallEnabled(1);
}

kuwehr_proper_intro()
{
	self.init_rezbar = false;
	for(;;)
	{
		if(!self.init_rezbar)
		{
			self freezecontrols(true);
			self rezbar_intro_init();
			wait 0.25;
			self statusBarBigEnabled();
			self statusBarBigMakeNote("jm_kuwehr_intro_text");
			if(isdefined(self.waypoint_mode_enabled)) self.waypoint_mode_enabled = true;
			self.init_rezbar = true;
		}
		else wait 0.05;
	}
}

kuwehr_main_door_small_locked_door()
{
	t = getent("kuwehr_main_door_door_trig","targetname");
	d = getent("kuwehr_main_door_door","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.has_main_door_key)
		{
			user addStatusBarItem(&"RZL_LOST_KEY");
			user.has_main_door_key = false; //Key magically returns to the pack.
			user.opened_main_door_pack = false; //Needed because maybe you didn't enter the door. Asshole.
			d playsound("use_key_in_lock");
			wait 0.8;
			d rotateyaw(-87,2,0.5,0.5);
			d playsound("kuwehr_open_door");
			wait 6;
			d rotateyaw(87,2,0.5,0.5);
			wait 1.7;
			d playsound("kuwehr_close_door");
			wait 0.3;
		}
		else 
		{
			d playsound("kuwehr_door_locked");
			wait 0.5;
			user iprintlnbold("The door is locked.");
		}
	}
}

kuwehr_library_door_entry()
{
	t = getent("kuwehr_library_enter","targetname");
	b = getent("kuwehr_library_paper_scrap","targetname");
	b.hidden = false;
	trig_target = getent(t.target,"targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.kuwehr_current_state != "reading")
		{
			if(!user.has_library_key)
			{
				user playsound("kuwehr_door_locked");
				wait 0.5;
				user iprintlnbold("The door is locked.");
				
				if(!user.took_library_door_note)
				{
					wait 2;
					user iprintlnbold("Upon inspection of the door you find that there's a note tacked to it.");
					wait 2.5;
					user iprintlnbold("You take the note and inspect it.");
					user.took_library_door_note = true;
					user addstatusbaritem(&"RZL_GOT_LIBRARY_SCRAP");
					wait 0.5;
					b hide();
					b notsolid();
					b.hidden = true;
					wait 1.5;
					user statusBarBigEnabled();
					user statusBarBigMakeNote("kuwehr_paper_scrap_rezbar_note");
				}
			}
			else
			{
				user freezecontrols(true);
				if(!isdefined(user.fadetoblack))
				{
					user.fadetoblack = newclienthudelem(user);
					user.fadetoblack.x = 0;
					user.fadetoblack.y = 0;
					user.fadetoblack.alignX = "left";
					user.fadetoblack.alignY = "top";
					user.fadetoblack.horzAlign = "fullscreen";
					user.fadetoblack.vertAlign = "fullscreen";	
					user.fadetoblack.alpha = 0;
					user.fadetoblack setshader("black", 650, 480);
				}	
				
				user statusBarSmallEnabled(0);
				user setclientcvar("hud_enable","0");
				user.fadetoblack fadeovertime(1);
				user.fadetoblack.alpha = 1;
				wait 1;
				
				user setorigin(trig_target.origin);
				user setplayerangles(trig_target.angles);
				
				trig_target playsound("use_key_in_lock");
				wait 0.8;
				trig_target playsound("kuwehr_open_door");
				wait 0.4;
				trig_target playsound("kuwehr_door_squeak");
				wait 5.8;
				trig_target playsound("kuwehr_close_door");
				wait 0.3;
				
				user.fadetoblack fadeovertime(1);
				user.fadetoblack.alpha = 0;
				user setclientcvar("hud_enable","1");
				user freezecontrols(false);
				wait 1;
				
				user statusBarSmallEnabled(1);
				wait 0.05;
			}
			if(b.hidden) 
			{
				b show();
				b solid();
				b.hidden = false;
			}
		}
	}
}

kuwehr_library_door_exit()
{
	t = getent("kuwehr_library_exit","targetname");
	trig_target = getent(t.target,"targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.has_library_key)
		{
			user playsound("kuwehr_door_locked");
			wait 0.5;
			user iprintlnbold("The door is locked.");
		}
		else
		{
			user freezecontrols(true);
			if(!isdefined(user.fadetoblack))
			{
				user.fadetoblack = newclienthudelem(user);
				user.fadetoblack.x = 0;
				user.fadetoblack.y = 0;
				user.fadetoblack.alignX = "left";
				user.fadetoblack.alignY = "top";
				user.fadetoblack.horzAlign = "fullscreen";
				user.fadetoblack.vertAlign = "fullscreen";	
				user.fadetoblack.alpha = 0;
				user.fadetoblack setshader("black", 650, 480);
			}	
			
			user statusBarSmallEnabled(0);
			user setclientcvar("hud_enable","0");
			user.fadetoblack fadeovertime(1);
			user.fadetoblack.alpha = 1;
			wait 1;
			
			user setorigin(trig_target.origin);
			user setplayerangles(trig_target.angles);
			
			trig_target playsound("use_key_in_lock");
			wait 0.8;
			trig_target playsound("kuwehr_open_door");
			wait 0.4;
			trig_target playsound("kuwehr_door_squeak");
			wait 5.8;
			trig_target playsound("kuwehr_close_door");
			wait 0.3;
			
			user.fadetoblack fadeovertime(1);
			user.fadetoblack.alpha = 0;
			user setclientcvar("hud_enable","1");
			user freezecontrols(false);
			wait 1;
			
			user statusBarSmallEnabled(1);
			wait 0.05;
		}
	}
}

pick_up_library_key()
{
	t = getent("kuwehr_library_key_trig","targetname");
	k = getent("kuwehr_library_key","targetname");
	pl = getent("kuwehr_libkey_plunger","targetname");
	
	pl hide();
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.has_library_key)
		{
			user freezecontrols(true);
			user holsterweapons("holster");
			user iprintlnbold("You try to pick up the key.");
			k movez(2,0.3, 0.1, 0.1);
			k waittill("movedone");
			k movez(-2,0.3, 0.1, 0.1);
			k waittill("movedone");
			k movez(2,0.3, 0.1, 0.1);
			k waittill("movedone");
			k movez(-2,0.3, 0.1, 0.1);
			k waittill("movedone");
			user iprintlnbold("Realising it's stuck in the feces, you whip out your plunger.");
			wait 1;
			pl show();
			user addstatusbaritem(&"RZL_USED_PLUNGER");
			wait 2;
			//playsound("PLUNGE"); MAKE A PLUNGING SOUND
			user addstatusbaritem(&"RZL_USED_PLUNGER");
			wait 2;
			pl hide();
			k movez(2,0.3, 0.1, 0.1);
			k waittill("movedone");
			k movez(-2,0.3, 0.1, 0.1);
			k waittill("movedone");
			//playsound("PLUNGE"); MAKE A PLUNGING SOUND
			wait 1;
			k movez(5,0.3);
			k waittill("movedone");
			k hide();
			k notsolid();
			
			user holsterweapons("retrieve");
			user iprintlnbold("You pick up the key.");
			
			user.has_library_key = true;
			user notify("got_to_seeking_item");
			if(isdefined(user.current_target)) user.current_target = &"RZL_SEEK_ITEM_NONE";
			user thread compareDistanceToEntity("none");
			
			user freezecontrols(false);
			
			wait 0.5;
			
			k movez(-5,0.3);
			k waittill("movedone");
			k show();
			k solid();
			
		}
		else user iprintlnbold("You already have this key.");
	}
}

user_wine_drinking()
{
	t = getent("kuwehr_take_a_swig","targetname");
	b = getent("kuwehr_take_a_swig_bottle","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		user freezecontrols(true);
		if((user.alco_tolerance==0) && (!user.drunk))
		{
			user holsterweapons("holster");
			b hide();
			b notsolid();
			b playsound("drunk_pick_up_bottle");
			wait 1.5;
			user.alco_tolerance++;
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user iprintlnbold("You don't feel anything yet.");
			wait 1;
			b show();
			b solid();
			b playsound("drunk_put_down_bottle");
			wait 0.1;
			user holsterweapons("retrieve");
		}
		else if((user.alco_tolerance==1) && (!user.drunk))
		{
			user holsterweapons("holster");
			b hide();
			b notsolid();
			b playsound("drunk_pick_up_bottle");
			wait 1.5;
			user.alco_tolerance++;
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			wait 0.2;
			user shellshock("duhoc_boatexplosion",2);
			user iprintlnbold("You feel happy all of a sudden!");
			wait 2.5;
			b show();
			b solid();
			b playsound("drunk_put_down_bottle");
			wait 0.1;
			user holsterweapons("retrieve");
		}
		else if((user.alco_tolerance==2) && (!user.drunk))
		{
			user holsterweapons("holster");
			b hide();
			b notsolid();
			b playsound("drunk_pick_up_bottle");
			wait 2;
			user.alco_tolerance++;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			user shellshock("duhoc_boatexplosion",3);
			wait 0.5;
			user iprintlnbold("You feel REALLY happy all of a sudden!!");
			wait 2.5;
			b show();
			b solid();
			b playsound("drunk_put_down_bottle");
			wait 0.1;
			user holsterweapons("retrieve");
		}
		else if((user.alco_tolerance==3) && (!user.drunk))
		{
			user holsterweapons("holster");
			b hide();
			b notsolid();
			b playsound("drunk_pick_up_bottle");
			wait 2;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			user thread happy_time_drunk();
			wait 0.5;
			user playlocalsound("drunk_small_swig");
			user.alco_tolerance++;
			user.drunk = true;
			wait 1;
			b show();
			b solid();
			b playsound("drunk_put_down_bottle");
			wait 0.1;
			user holsterweapons("retrieve");
		}
		else
		{
			user iprintlnbold("Y3r Dr%nk&&!");
			wait 1;
		}
		
		user freezecontrols(false);
	}
}

happy_time_drunk()
{
	if(!isdefined(self.fadetoblack))
	{
		self.fadetoblack = newclienthudelem(self);
		self.fadetoblack.x = 0;
		self.fadetoblack.y = 0;
		self.fadetoblack.alignX = "left";
		self.fadetoblack.alignY = "top";
		self.fadetoblack.horzAlign = "fullscreen";
		self.fadetoblack.vertAlign = "fullscreen";	
		self.fadetoblack setshader("black", 650, 480);
	}
	
	self.fadetoblack.alpha = 0;
	self.fadetoblack fadeovertime(1);
	self.fadetoblack.alpha = 0.5;
	wait 1;
	self thread pulsing_fade();
	self thread shellshock_drunk();
	wait 12.7;
	if(!self.reading_book)
	{
		self freezecontrols(true);
		self playlocalsound("drunk_body_fall");
		wait 0.3;
		self setclientcvar("snd_Volume","0");
		self.drunk = false;
		self setorigin((-230, 1232, 140));
		for(i=21;i>0;i--)
		{
			self.fadetoblack.alpha = 1;
			wait 0.05;
		}
		wait 0.5;
		
		self iprintlnbold("You pass out and wake up some time later.");
		wait 3;
		self.fadetoblack fadeovertime(1);
		self.fadetoblack.alpha = 0;
		self setclientcvar("snd_Volume","0.1");
		wait 0.1;
		self setclientcvar("snd_Volume","0.2");
		wait 0.1;
		self setclientcvar("snd_Volume","0.3");
		wait 0.1;
		self setclientcvar("snd_Volume","0.4");
		wait 0.1;
		self setclientcvar("snd_Volume","0.5");
		wait 0.1;
		self setclientcvar("snd_Volume","0.6");
		wait 0.1;
		self setclientcvar("snd_Volume","0.7");
		wait 0.1;
		self setclientcvar("snd_Volume","0.8");
		wait 0.1;
		self setclientcvar("snd_Volume","0.9");
		wait 0.1;
		self setclientcvar("snd_Volume","1");
		wait 0.1;
		
		self.alco_tolerance=0;
		wait 0.5;
		
		self freezecontrols(false);
	}
}

pulsing_fade()
{
	for(;;)
	{
		if(self.drunk)
		{
			self.fadetoblack.alpha = 0.5;
			self.fadetoblack fadeovertime(0.5);
			self.fadetoblack.alpha = 0.75;
			wait 0.5;
			self.fadetoblack fadeovertime(0.5);
			self.fadetoblack.alpha = 0.5;
			wait 0.5;
		}
		else break;
	}
}
shellshock_drunk()
{
	for(;;)
	{
		if(self.drunk)
		{
			self shellshock("duhoc_boatexplosion",10);
			wait 7;
		}
		else break;
	}
}

found_the_right_book()
{
	t = getent("kuwehr_right_book_trig","targetname");
	b = getent("kuwehr_right_book","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.kuwehr_current_state != "reading")
		{
			user holsterweapons("holster");
			b hide();
			b notsolid();
			if(user.drunk)
			{
				user.reading_book = true;
				user addStatusBarItem(&"RZL_GOT_CORRECT_BOOK_DRUNK");
				wait 1;
				user readbook("library_correct_book_open_haze");
				
				user thread compareDistanceToEntity("key_to_part_two_seek");
				if(isdefined(user.current_target)) user.current_target = &"RZL_SEEK_ITEM_KEY";
			}
			else
			{
				if(!user.note_from_book_dropped)
				{
					user.note_from_book_dropped = true;
					wait 0.5;
					user iprintlnbold("You open the book and a small note falls out of it.");
					user statusBarBigEnabled();
					user statusBarBigMakeNote("library_unclear_mind_hint");
					user waittill("done_checking_rezbar_big");	
					wait 0.5;
				}
				user addStatusBarItem(&"RZL_GOT_CORRECT_BOOK");
				wait 1;
				user readbook("library_correct_book_open_nohaze");
			}
			
			user waittill("done_reading");
			
			if(user.drunk)
			{
				user freezecontrols(true);
				user playlocalsound("drunk_body_fall");
				wait 0.3;
				user setclientcvar("snd_Volume","0");
				user.drunk = false;
				user setorigin((-230, 1232, 140));
				for(i=21;i>0;i--)
				{
					user.fadetoblack.alpha = 1;
					wait 0.05;
				}
				wait 2;

				user iprintlnbold("You pass out and wake up some time later.");
				wait 3;
				user.fadetoblack fadeovertime(1);
				user.fadetoblack.alpha = 0;
				user setclientcvar("snd_Volume","0.1");
				wait 0.1;
				user setclientcvar("snd_Volume","0.2");
				wait 0.1;
				user setclientcvar("snd_Volume","0.3");
				wait 0.1;
				user setclientcvar("snd_Volume","0.4");
				wait 0.1;
				user setclientcvar("snd_Volume","0.5");
				wait 0.1;
				user setclientcvar("snd_Volume","0.6");
				wait 0.1;
				user setclientcvar("snd_Volume","0.7");
				wait 0.1;
				user setclientcvar("snd_Volume","0.8");
				wait 0.1;
				user setclientcvar("snd_Volume","0.9");
				wait 0.1;
				user setclientcvar("snd_Volume","1");
				wait 0.1;
				
				user.alco_tolerance=0;
				
				wait 1;
				user freezecontrols(false);
				
				user.solved_puzzle=true;
			}
			user.reading_book = false;
			b show();
			b solid();
			user holsterweapons("retrieve");
		}
	}
}

key_under_rug()
{
	t = getent("kuwehr_hidden_key_to_part_two","targetname");
	while(1)
	{
		t waittill("trigger", user);
		if((user.solved_puzzle) && (!user.has_key_to_part_two))
		{
			user.has_key_to_part_two = true;
			user addStatusBarItem(&"RZL_GOT_KEY_TO_PART_TWO");
			user notify("got_to_seeking_item");
			if(isdefined(user.current_target)) user.current_target = &"RZL_SEEK_ITEM_NONE";
			user thread compareDistanceToEntity("none");
		}
	}
}

kuwehr_enter_part_two()
{
	t = getent("kuwehr_part_two_enter","targetname");
	o = getent("kuwehr_finish_origin","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.has_key_to_part_two)
		{
			user freezecontrols(true);
			if(!isdefined(user.fadetoblack))
			{
				user.fadetoblack = newclienthudelem(user);
				user.fadetoblack.x = 0;
				user.fadetoblack.y = 0;
				user.fadetoblack.alignX = "left";
				user.fadetoblack.alignY = "top";
				user.fadetoblack.horzAlign = "fullscreen";
				user.fadetoblack.vertAlign = "fullscreen";	
				user.foreground = 1;
				user.fadetoblack.alpha = 0;
				user.fadetoblack setshader("black", 650, 480);
			}	
			
			user statusBarSmallEnabled(0);
			user setclientcvar("hud_enable","0");
			user.fadetoblack fadeovertime(1);
			user.fadetoblack.alpha = 1;
			wait 1;
			
			user setorigin(o.origin);
			
			user playsound("use_key_in_lock");
			wait 0.8;
			user playsound("kuwehr_open_door");
			wait 0.4;
			user playsound("kuwehr_door_squeak");
			wait 5.8;
			user playsound("kuwehr_close_door");
			wait 0.3;
			
			user.fadetoblack fadeovertime(1);
			user.fadetoblack.alpha = 0;
			user setclientcvar("hud_enable","1");
			user freezecontrols(false);
			wait 1;
			
			user statusBarSmallEnabled(1);
			wait 0.05;
		}
		else {
			user playsound("kuwehr_door_locked");
			wait 0.5;
			user iprintlnbold("The door is locked.");
		}
	}
}
cinematic_rez_courtyard()
{
	t = getent("kuwehr_waypoint_7_trig","targetname");
	
	for(;;)
	{
		t waittill("trigger", user);
		if(!isdefined(user.triggered_cn_courtyard)) user.triggered_cn_courtyard = false;
		if(!self.triggered_cn_courtyard) 
		{
			self.triggered_cn_courtyard = true;
			user thread cn_rez_courtyard_code();
		}
	}
}

cn_rez_courtyard_code()
{
	num_origins = 5;
	o = [];
	for(i=0;i<=num_origins;i++) o[i] = getent("kuwehr_cn_rezyard_"+i+"","targetname");

	self freezecontrols(true);
	
	if(!isdefined(self.fadetoblack))
	{
		self.fadetoblack = newclienthudelem(self);
		self.fadetoblack.x = 0;
		self.fadetoblack.y = 0;
		self.fadetoblack.alignX = "left";
		self.fadetoblack.alignY = "top";
		self.fadetoblack.horzAlign = "fullscreen";
		self.fadetoblack.vertAlign = "fullscreen";	
		self.foreground = 1;
		self.fadetoblack.alpha = 0;
		self.fadetoblack setshader("black", 650, 480);
	}
	
	self.fadetoblack fadeovertime(1);
	self.fadetoblack.alpha = 1;
	wait 1.05;
	
	
	o[0] enablelinkto();
	self linkto(o[0]);
	
	revert_origin = o[0].origin;
	
	self setorigin(o[0].origin);
	self setplayerangles(o[0].angles);
	self makeCinematic(true);
	self makeCamera(true);
	self holsterWeapons("holster");
	
	self thread rotatePlayerAngles("clockwise", 35, false, 1.5);
	o[0] moveto(o[1].origin+(15,0,0), 1.7);
	wait 0.3;
	
	self playlocalsound("kuwehr_cn_medley_1");
	
	self.fadetoblack fadeovertime(1);
	self.fadetoblack.alpha = 0;
	wait 1.3;
	self thread rotatePlayerAngles("clockwise", 45, false, 1.5);
	o[0] moveto(o[2].origin-(0,0,20), 2.4);
	wait 2.3;
	self thread rotatePlayerAngles("clockwise", 55, false, 1.7);
	o[0] moveto(o[3].origin, 2.6);
	wait 1.6;
	
	self.fadetoblack fadeovertime(1);
	self.fadetoblack.alpha = 1;
	wait 1.05;
	
	o[0].origin = o[4].origin-(0,0,50);
	
	temp = o[5].origin-(0,0,50);
	
	self setplayerangles(o[5].angles);
	o[0] moveto(temp, 2.5);
	wait 0.25;
	self.fadetoblack fadeovertime(1);
	self.fadetoblack.alpha = 0;
	wait 1.75;
	self.fadetoblack fadeovertime(0.5);
	self.fadetoblack.alpha = 1;
	wait 0.55;
	self unlink();
	self setorigin(revert_origin);
	self setplayerangles(o[5].angles);
	self holsterWeapons("retrieve");
	wait 0.3;
	
	self.fadetoblack fadeovertime(1);
	self.fadetoblack.alpha = 0;
	self makeCinematic(false);
	self makeCamera(false);
	self freezecontrols(false);
}

easter_egg_1()
{
	t = getent("kuwehr_easteregg_wtf1","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		user setorigin((-7748, 652, -711));
		user iprintlnbold("^3(^9'''^3)(^9 ^-^ ^3)(^9'''^3)");
		wait 2;
	}
}

easter_egg_2()
{
	t = getent("kuwehr_end_piano","targetname");
	org = getent("kuwehr_end_piano_snd","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		rnd = randomint(11);
		if(rnd==0) org playsound("piano_a1");
		else if(rnd==1) org playsound("piano_a2");
		else if(rnd==2) org playsound("piano_b1");
		else if(rnd==3) org playsound("piano_b2");
		else if(rnd==4) org playsound("piano_c1");
		else if(rnd==5) org playsound("piano_c2");
		else if(rnd==6) org playsound("piano_d1");
		else if(rnd==7) org playsound("piano_d2");
		else if(rnd==8) org playsound("piano_e1");
		else if(rnd==9) org playsound("piano_e2");
		else if(rnd==10) 
		{
			org playsound("easter_egg_piano");
			wait 6;
		}
		wait 1;           
	}

}
getTemplatedDoors()
{
	door = getentarray("kuwehr_door_template","targetname");
	entrance = getentarray("kuwehr_door_template_entrance","targetname");
	exit = getentarray("kuwehr_door_template_exit","targetname");
	
	if((door.size==entrance.size) && (door.size==exit.size))
	{
		for(i=0;i<door.size;i++)
		{
			door[i].open = false;
			door[i].opening = false;
			entrance[i] thread monitorEntrance(door[i], entrance[i], exit[i]);
			exit[i] thread monitorEntrance(door[i], entrance[i], exit[i]);
		}
	}
}

monitorEntrance(door, entrance, exit)
{
	while(1)
	{
		self waittill("trigger", user); //either entrance or exit
		door.opening = true;
		if(!door.open) 
		{
			door playsound("kuwehr_open_door");
			door rotateyaw(90, 1, 0.3, 0.3);
			door.open = true;
		}
		else 
		{
			door rotateyaw(-90, 1, 0.3, 0.3);
			wait 0.8;
			door playsound("kuwehr_close_door");
			door.open = false;
		}
		entrance triggerOff();
		exit triggerOff();
		door waittill("rotatedone");
		door.opening = false;
		entrance triggerOn();
		exit triggerOn();
	}
}
kuwehr_end_money()
{
	m = getent("kuwehr_respawning_money","targetname");
	t = getent("kuwehr_respawning_money_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.kuwehr_money < 100)
		{
			m hide();
			m notsolid();
			user.kuwehr_money = 100;
			//user playlocalsound("got_money");
			wait 1;
			m show();
			m solid();
		}
		else user iprintlnbold("Your money is already at least 100^2$^7.");
	}	
}
monitorMoney()
{
	for(;;)
	{
		if(self.kuwehr_money < 0) self.kuwehr_money = 0;
		if(isdefined(self.HUDmoney_left)) self.HUDmoney_left setValue(self.kuwehr_money);
		wait 0.1;
	}
}
end_barrier_1()
{
	t = getent("kuwehr_end_barrier_1_500bucks","targetname");
	b = getent("kuwehr_money_barrier_1","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.kuwehr_money>=500)
		{
			b hide();
			b notsolid();
			user.kuwehr_money -= 500;
			t delete();
		}
		else user iprintlnbold("You don't have enough money to remove this barrier.");
	}
}
end_barrier_2()
{
	t = getent("kuwehr_money_barrier_2_1000bucks","targetname");
	b_a = getent("kuwehr_money_barrier_2a","targetname");
	b_b = getent("kuwehr_money_barrier_2b","targetname");
	c = getent("kuwehr_money_barrier_2_clip","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.kuwehr_money>=1000)
		{
			b_a hide();
			b_a notsolid();
			wait 0.05;
			b_b hide();
			b_b notsolid();
			wait 0.05;
			c movez(10000,1);
			user.kuwehr_money -= 1000;
			t delete();
		}
		else user iprintlnbold("You don't have enough money to remove this barrier.");
	}
}
kuwehr_mansion_enter()
{
	t = getent("kuwehr_end_mansion_entrance","targetname");
	o = getent("kuwehr_end_mansion_entrance_org","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		user setorigin(o.origin);
		user setplayerangles(o.angles);
		wait 0.5;
	}
}
kuwehr_end()
{
	t = getent("kuwehr_finish_trigger","targetname");
	while(1)
	{
		t waittill("trigger", user);
		if(!user.finished_kuwehr)
		{
			user.finished_kuwehr = true;
			user iprintlnbold("Congratulations," +user.name, "^7 you have finished jm^2_^7kuwehr!");
			wait 1;
			user iprintlnbold("This map was made by rezil^2.");
			wait 2;
			user iprintlnbold("Hope you enjoyed it^2!");
			wait 2;
			user iprintlnbold("Contact via codjumper^2.^7com or xfire ^2: ^7saberteeth");
			wait 5;
			if(!user.opened_updater_pack) 
			{
				user iprintlnbold("You have missed the 'Seek Mode' update for your rezBar(tm)! Go look for it!");
				wait 2;
			}
			if(!user.opened_rezpod_pack)
			{
				user iprintlnbold("You missed the rezPod(tm) for your rezBar(tm)! Find it!");
				wait 2;
			}
			user iprintlnbold("^2!! ^7Stay tuned for jm_kuwehr 2 ^2!! ^7Bye! :>");
		}
	}          
}